# Makefile for OpenCL programs

# NVIDIA OpenCL:
OPENCLINC=/usr/local/cuda/include
OPENCLLIB=/usr/lib/nvidia-current
LDLIBS += -lcuda

# ATI OpenCL, 64-bit:
#OPENCLINC=$(HOME)/AMD-APP-SDK-v2.4-lnx64/include
#OPENCLLIB=$(HOME)/AMD-APP-SDK-v2.4-lnx64/lib/x86_64/

OPTS=-O3 -Wall

CXXFLAGS+=-I$(OPENCLINC) $(OPTS) 

ifeq ("$(shell uname -s)","Darwin")
   LDLIBS += -framework OpenCL -framework OpenGL -framework AppKit
else
   LDLIBS +=-L$(OPENCLLIB) -lOpenCL $(LFLAGS)
endif


# Compilers:
CXX=g++

all: $(ALL)

run: $(ALL)
	for exe in $(ALL); do ./$$exe || exit 1; done

