/**
Bit interleaved array indexing test for EPGPU OpenCL library.

Dr. Orion Lawlor, lawlor@alaska.edu, 2011-05-16 (Public Domain)
*/
#include <iostream>
#include <stdlib.h>
#include "epgpu.h" /* Orion Lawlor's Expressive Programming for GPU library */
#include "epgpu.cpp" /* <- just compile it here, now.  No compiler/DLL hassles! */

int main(int argc,char *argv[]) {
	int w,h; w=h=16;
	if (argc>2) {w=atoi(argv[1]); h=atoi(argv[2]); }
	
	static GPU_KERNEL_2D(writeArray, (int w, __global<int *> dest),
		dest[i+j*w]=interleave2D(i,j);
	)
	
	gpu_vector2d<int> bar(w,h);
	bar=writeArray(w,bar);
	
	std::cout<<"result at "<<w<<"x"<<h<<":\n";
	for (int j=0;j<h;j++) {
		for (int i=0;i<w;i++)
			printf("%02x ",bar(i,j));
		printf("\n");
	}
	
	return 0;
}
