#include <stdio.h>
#include <map>
#include "indexlist.h"



#define matchwrite_indexes(makeindex) \
	makeindex(0,result, i); \

GPU_INDEX_SET(matchwrite,
	/* empty */ ,(){}, 
	1,matchwrite_indexes);



#define stencil1Dindexes(makeindex) \
	makeindex(0,L, i-1); \
	makeindex(1,C, i); \
	makeindex(2,R, i+1); \

GPU_INDEX_SET(stencil1D,
	/* empty */ ,(){}, 
	3,stencil1Dindexes);


#define stencil2D5indexes(makeindex) \
	makeindex(0,L, (i-1)+(j)*w); \
	makeindex(1,C,   (i)+(j)*w); \
	makeindex(2,R, (i+1)+(j)*w); \
	makeindex(3,T, (i)+(j+1)*w); \
	makeindex(4,B, (i)+(j-1)*w); \

GPU_INDEX_SET(stencil2D5, 
	int w,(int w_){w=w_;}, 
	5,stencil2D5indexes);


index_generator::~index_generator() {/* do nothing */}

/**
  Stores global memory indexes in local scratchpad.
*/
class scratchpad_assignments {
public:
	scratchpad_assignments() {max_used=0;}
	
	/* Write this global index to the scratchpad.
	   Returns the scratchpad index where the data is
	   to be written.
	*/
	int write(int gidx) {
		int already=read(gidx);
		if (already>=0) return already;
		return 0; // FIXME?
	}
	
	/* Read this global index from the scratchpad.
		Returns the scratchpad index if present,
		or -1 if not present.
	*/
	int read(int gidx) {
		return 0; // FIXME?
	}
	
	
private:
	/* Scratch pad is a minimum of 16KB */
	enum {max_scratch=16*1024};
	int assignments[max_scratch];
	int max_used;
	
	/* Map global index to scratchpad index */
	typedef std::map<int,int> G2S_t;
	G2S_t G2S;
};

/* Print (to stdout) the indexes generated here */
void dumpindex(const index_generator &gen,int i,int j=0,int k=0)
{
	int m=gen.get_index_count();
	int idx[m]; gen.get_indexes(idx,i,j,k);
	for (int n=0;n<m;n++) {
		printf(" (%d,%d,%d) -> %s %d (%s)\n",
			i,j,k,
			gen.get_index_name(n),
			idx[n],
			gen.get_index_code(n)
		);
	}
}


int main() {
	printf("Stencil1D:\n");
	dumpindex(stencil1D(),100);
	
	stencil2D5 sa(1000);
	printf("Stencil2D5(1000):\n");
	dumpindex(sa,100,10);

	stencil2D5 sb(10000);
	printf("Stencil2D5(10000):\n");
	dumpindex(sb,100,10);
	
	return 0;
}
