/**
Tiny example for EPGPU library.

Dr. Orion Lawlor, lawlor@alaska.edu, 2011-04-27 (Public Domain)
*/
#include <iostream>
#include "epgpu.h" /* Orion Lawlor's Expressive Programming for GPU library */
#include "epgpu.cpp" /* <- just compile it here, now.  No compiler/DLL hassles! */

/* Simple little kernel running on GPU.
     Reads from "i", which is our array index.
	 Writes to "result", which gets stored in our array.
*/
GPU_FILLKERNEL(float,
do_work,(float k),
	result = i+k;
)

int main() {
	int n=1000;

	gpu_vector<float> arr(n); /* make storage on GPU */
	
	arr=do_work(10000.3); /* run code on GPU */
	
	for (int i=0;i<n;i+=100) { /* spot-check the result */
		std::cout<<"arr["<<i<<"] = "<<arr[i]<<"\n";
	}
	
	return 0;
}
