/* Demonstrate shared C++/OpenCL structs/classes, with constructors. 
  Dr. Orion Sky Lawlor, 2011-06-15 (Public Domain)
*/
#include "epgpu.h"
#include "epgpu.cpp"
#include <stdlib.h> /* for rand */
#include <iostream>

float randFloat() {
	return (rand()%1024)/1024.0;
}
GPU_STRUCT(vec3,
	float x; float y; float z; // location in 3D
, // C++ only stuff:
	vec3(float s=1.0) {
		x=s*randFloat(); y=s*randFloat(); z=s*randFloat();
	}
);
GPU_STRUCT(particle,
	vec3 pos;  // position of particle
	unsigned char v; // color
, // C++ only stuff:
	particle() {
		v=randFloat()*255;
	}
);
GPU_FILLKERNEL(float,test_struct,(__global<particle *> part),
	result=part[i].pos.y;
)

int main() {
	particle p[2];
	gpu_vector<particle> part(2,p);
	gpu_vector<float> out(2);
	out=test_struct(part);
	std::cout<<"GPU p[0]="<<out[0]<<"   vs CPU "<<p[0].pos.y<<"\n";
	std::cout<<"GPU p[1]="<<out[1]<<"   vs CPU "<<p[1].pos.y<<"\n";
	return 0;
}
